<?php

namespace Treewec\Admin;

/**
 * Test class for FileRenameForm.
 * Generated by PHPUnit on 2012-06-23 at 09:54:07.
 * @group admin_fileform
 */
class FileRenameFormTest extends \PHPUnit_Framework_TestCase {

    /** @var FileRenameForm */
    private $formObject;

    protected function setUp() {
        $_POST['submit'] = 'submit';
        $this->formObject = new FileRenameForm('submit', true);        
    }

    public function testSuccessRename() {
        $fileNames = array(
            'test' => 'another', // ascii name to ascii name
            'another' => 'žeš-morašice', // ascii name to diacritic name
            'žeš-morašice' => 'Morašice', // diacritic to diacritic
            'Morašice' => 'test', // diacritic to ascii
        );
        $this->assertRename('assertSuccessRename', $fileNames);
    }

    public function testExistingNames() {
        $this->assertRename('assertFailRename', array('test' => 'existing'));
        $this->assertRename('assertFailRename', array('test' => 'existing-žeš'));
    }

    public function testInvalidNames() {
        $this->assertRename('assertFailRename', array('test' => ''));
        $this->assertRename('assertFailRename', array('test' => 'ahoj dsa'));
        $this->assertRename('assertFailRename', array('test' => '*/?dsa#da'));
        $this->assertRename('assertFailRename', array('test' => 'dir/dir'));
    }

    public function testMainPublicationFolder() {
        $this->setFormAndProcess(TREEWEC_VIEW_DIR, 'newName');
        parent::assertFalse($this->formObject->isValid());
    }

    public function testInvalidPath() {
        $this->setFormAndProcess(new \Exception(), 'newName');
        parent::assertFalse($this->formObject->isValid());
    }

    public function assertRename($method, $fileNames) {
        $isFileValues = array(true, false);
        foreach ($isFileValues as $isFile) {
            foreach ($fileNames as $oldName => $newName) {
                $this->formObject = new FileRenameForm('submit', true); // to remove old errors
                $this->$method($oldName, $newName, $isFile);
            }
        }
    }

    private function assertSuccessRename($oldName, $newName, $isFile) {
        $this->setFormAndProcess($this->getPath($oldName, $isFile), $newName);
        parent::assertTrue($this->formObject->isValid());
        parent::assertTrue(file_exists($this->getPath($newName, $isFile)));
        parent::assertFalse(file_exists($this->getPath($oldName, $isFile)));
    }

    private function assertFailRename($oldName, $newName, $isFile) {
        $this->setFormAndProcess($this->getPath($oldName, $isFile), $newName);
        parent::assertFalse($this->formObject->isValid());
        parent::assertTrue(file_exists($this->getPath($oldName, $isFile)));
    }

    private function setFormAndProcess($oldPath, $newName) {
        $_POST['new_name'] = $newName;
        $this->formObject->setSuccessAction(FormSuccessAction::NOTHING);
        $this->formObject->setFilePath($oldPath);        
        $this->formObject->process();
    }

    private function getPath($name, $isFile) {
        $extension = $isFile ? '.php' : '';
        return \Treewec\FileSystem\Path::toFileSystem(TEMP_FILEDIR . $name . $extension);
    }

}

?>